
// Creates random-access file by writing 100 empty records to disk.
import java.io.IOException;
import java.io.RandomAccessFile;


public class CreateRandomFile
{    
   public static final int NUMBER_RECORDS = 100;
   CreateRandomFileTest rft=new CreateRandomFileTest();
   // enable user to select file to open
   public void createFile()
   {
      RandomAccessFile file = null;

      try // open file for reading and writing
      {           
         file = new RandomAccessFile( "clients.dat", "rw" );

         RandomAccessAccountRecord blankRecord = 
            new RandomAccessAccountRecord();

         // write 100 blank records
         for ( int count = 0; count < NUMBER_RECORDS; count++ )
            blankRecord.write( file );

         // display message that file was created
         System.out.println( "Created file clients.dat." );

         rft.ta.append("Created File clients.dat with 100 blank records");
      } // end try
      catch ( IOException ioException )
      {
         System.err.println( "Error processing file." );
         System.exit( 1 );
      } // end catch
      finally
      {
         try
         {
            if ( file != null )
               file.close(); // close file
         } // end try
         catch ( IOException ioException )
         {
            System.err.println( "Error closing file." );
            System.exit( 1 );
         } // end catch
      } // end finally
   } // end method createFile
} // end class CreateRandomFile
