//George Koutsogiannakis
// Testing class CreateRandomFile.
//3/7/07

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.RandomAccessFile;
import java.io.IOException;

public class CreateRandomFileTest extends JFrame
{    

   Container c=getContentPane();
   RandomAccessAccountRecord raar;
   RandomAccessFile file;
   static CreateRandomFile application;
   static JTextArea ta;

   int account;
   String first;
   String last;
   double bal;

  
   public CreateRandomFileTest()
   {


   }
   //above default constructor is used for a dummy 
   //reference to gain access to othe rmethods of this clas
   //without creatingthe GUI
   
   public CreateRandomFileTest(String str)
   {

		super(str);
		buildGUI();
	}

	public void buildGUI()
	{
		BorderLayout layout=new BorderLayout(5,5);
		JPanel panel=new JPanel();
		ta=new JTextArea(20,50);
		JScrollPane textscrollpane=new JScrollPane(ta);
		panel.add(textscrollpane);
		c.add(panel, BorderLayout.NORTH);
		setSize(800, 700);
		setVisible(true);

		JButton b=new JButton("Exit");
		b.setPreferredSize(new Dimension(150, 50));
		c.add(b, BorderLayout.EAST);
		b.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				System.exit(0);
			}
		}
		);


		JButton b1=new JButton("Read");
		b1.setPreferredSize(new Dimension(150,50));
		JButton b2=new JButton("Write");
		c.add(b1, BorderLayout.CENTER);
		c.add(b2, BorderLayout.WEST);


		//write into the file

		b2.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				try
				{
					raar=new RandomAccessAccountRecord(25, "george", "kay", 3.25);
					//the above class provide sthe methods to construct a record
					//to read or write a record. It constructs a record by 
					//calling the its super class Account
					file=new RandomAccessFile("Clients.dat", "rw");
					raar.write(file);
					//the above call writes the default record created above by the constructor

					Object[] options={ "OK", "NO", "CANCEL"};

					int optionint=JOptionPane.showOptionDialog (null,
					"Press OK if you want to create more records" ,
					"Warning", JOptionPane.YES_NO_CANCEL_OPTION,
					JOptionPane.WARNING_MESSAGE, null, options, options[0]);
					if(optionint==JOptionPane.YES_OPTION)
					{
						file.seek(0);
						for(int count=0; count<application.NUMBER_RECORDS; count++)
						{
							raar=new RandomAccessAccountRecord(count, "george"+count,
							"kay"+count, 3.25*count);
							raar.write(file);
						}
					
					}
					if(optionint==JOptionPane.NO_OPTION)
					{
							//add something else to do
					}
					if(optionint==JOptionPane.CANCEL_OPTION)
					{

						//add something else to do
					}

				}//end of try
				catch(IOException exc){}
				finally
				{
						try
						{
							if(file!=null)
							file.close();
						}
						catch(IOException ioException)
						{
							System.err.println("Error closing file");
							System.exit(1);
						}
				}

			}

		}
		); //end of anonymous inner class


		//READ FROM FILE

		b1.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				try
				{
					file=new RandomAccessFile("clients.dat", "rw");
					long l=file.length();

					ta.append("\n"+"The length of the file is :"+" "+l);
					file.seek(0);
					for(int count=0; count<application.NUMBER_RECORDS; count++)
					{
							raar.read(file);
							//the above method read calls set methods of AccountRecord to 
							//set the info. from teh file to the AccountRecord onbject
							//a get is then needed to get the value
							account=raar.getAccount();

							ta.append("\n"+"The accountis:"+account+"at cursor position"+" "+file.getFilePointer());
							first=raar.getFirstName();
							last=raar.getLastName();
							bal=raar.getBalance();
							ta.append("\n"+"The first name is:"+first+"at cursor position:"+" "+file.getFilePointer());	
							ta.append("\n"+"The last name is:"+last+"at cursor position:"+" "+file.getFilePointer());
							ta.append("\n"+"The balance is:"+bal+"at cursor position"+file.getFilePointer());
					}
				}
				catch(IOException exc){}
				finally
				{
						try
						{
							if(file!=null)
							file.close();
						}
						catch(IOException ioException)
						{
							System.err.println("Error closing file");
							System.exit(1);
						}
				}
			
			
			}//end of acionPerformed

		}
					
	); //end of anonymous inner class
   }//end of buildGUI method

   public static void main( String[] args)
   {
      CreateRandomFileTest crft = new CreateRandomFileTest("Random Access File Test");
      application=new CreateRandomFile();
	  application.createFile();
   } // end main
} // end class CreateRandomFileTest

